package com.alterdekim.hearthhack.component.processor.client.request.generic;

import com.alterdekim.Protocol;
import com.alterdekim.hearthhack.component.TcpConnection;
import com.alterdekim.hearthhack.util.BattleNetPacket;

import static com.alterdekim.hearthhack.util.GameUtilities.generateNotification;
import static com.alterdekim.hearthhack.util.GetAccountInfoRequest.ARCANE_DUST_BALANCE;

public class DustBalance extends GenericParser {

    @Override
    public void parseGenericRequest(int token, TcpConnection conn) throws Exception {
        Protocol.ArcaneDustBalance dustBalance = Protocol.ArcaneDustBalance.newBuilder()
                .setBalance(conn.getUserService().getDustForUserId(conn.getUserId()))
                .build();

        Protocol.Notification n = generateNotification(262, dustBalance.toByteString(), dustBalance.getSerializedSize());

        Protocol.Header header = Protocol.Header.newBuilder()
                .setServiceId(4)
                .setMethodId(1)
                .setToken(conn.nextToken())
                .setObjectId(0)
                .setSize(n.getSerializedSize())
                .setStatus(0)
                .build();

        conn.send(new BattleNetPacket(header, n.toByteArray()));
    }

    @Override
    public int getId() {
        return ARCANE_DUST_BALANCE.getValue();
    }
}
